Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/file.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/file.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/file.f90	(revision 5600)
@@ -530,7 +611,21 @@
       !----------------------------------------------------------------
       file_check_var_dim=.TRUE.
+
       ! check used dimension 
-      IF( ANY( td_var%t_dim(:)%l_use .AND. &
-      &        td_var%t_dim(:)%i_len /= td_file%t_dim(:)%i_len) )THEN
+      ll_error=.FALSE.
+      DO ji=1,ip_maxdim
+         il_ind=dim_get_index( td_file%t_dim(:), &
+         &                     TRIM(td_var%t_dim(ji)%c_name), &
+         &                     TRIM(td_var%t_dim(ji)%c_sname))
+         IF( il_ind /= 0 )THEN
+         IF( td_var%t_dim(ji)%l_use  .AND. &
+         &   td_file%t_dim(il_ind)%l_use .AND. &
+         &   td_var%t_dim(ji)%i_len /= td_file%t_dim(il_ind)%i_len )THEN
+            ll_error=.TRUE.
+         ENDIF
+         ENDIF
+      ENDDO
+
+      IF( ll_error )THEN
 
          file_check_var_dim=.FALSE.
@@ -542,30 +637,37 @@
 
 
-         CALL logger_debug( &
-         &  " file dimension: "//TRIM(fct_str(td_file%i_ndim))//&
-         &  " variable dimension: "//TRIM(fct_str(td_var%i_ndim)) )
-         il_ndim=MIN(td_var%i_ndim, td_file%i_ndim )
-         DO ji = 1, il_ndim
-            CALL logger_debug( &
-            &  " FILE CHECK VAR DIM: for dimension "//&
-            &  TRIM(td_file%t_dim(ji)%c_name)//&
-            &  ", file length: "//&
-            &  TRIM(fct_str(td_file%t_dim(ji)%i_len))//&
-            &  ", variable length: "//&
-            &  TRIM(fct_str(td_var%t_dim(ji)%i_len))//&
-            &  ", variable used "//TRIM(fct_str(td_var%t_dim(ji)%l_use)))
+         cl_dim='(/'
+         DO ji = 1, td_file%i_ndim
+            IF( td_file%t_dim(ji)%l_use )THEN
+               cl_dim=TRIM(cl_dim)//&
+               &  TRIM(fct_upper(td_file%t_dim(ji)%c_sname))//':'//&
+               &  TRIM(fct_str(td_file%t_dim(ji)%i_len))//','
+            ENDIF
          ENDDO
+         cl_dim=TRIM(cl_dim)//'/)'
+         CALL logger_debug( " file dimension: "//TRIM(cl_dim) )
+
+         cl_dim='(/'
+         DO ji = 1, td_var%i_ndim
+            IF( td_var%t_dim(ji)%l_use )THEN
+               cl_dim=TRIM(cl_dim)//&
+               &  TRIM(fct_upper(td_var%t_dim(ji)%c_sname))//':'//&
+               &  TRIM(fct_str(td_var%t_dim(ji)%i_len))//','
+            ENDIF
+         ENDDO
+         cl_dim=TRIM(cl_dim)//'/)'
+         CALL logger_debug( " variable dimension: "//TRIM(cl_dim) )
+
       ELSE
-         IF( ANY( td_var%t_dim(:)%l_use .AND. &
-         &  .NOT. td_file%t_dim(:)%l_use ) )THEN
-            
-            CALL logger_info("FILE CHECK VAR DIM: variable use more dimension "//&
-            &  " than file do until now. file dimension use will change.")
-
-         ENDIF
+
+         IF( td_var%i_ndim >  td_file%i_ndim )THEN
+            CALL logger_info("FILE CHECK VAR DIM: variable "//&
+            &  TRIM(td_var%c_name)//" use more dimension than file "//&
+            &  TRIM(td_file%c_name)//" do until now.")
+         ENDIF
+
       ENDIF
 
    END FUNCTION file_check_var_dim
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine add a variable structure in a file structure.<br/>
@@ -577,14 +679,12 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] td_var : variable structure
-   !
-   !> @todo 
-   !> - check dimension order
-   !> - voir pour ajouter variable avec plus de dim que deja presente dans fichier
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - add dimension to file if need be
+   !> - do not reorder dimension from variable, before put in file
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] td_var       variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE file_add_var(td_file, td_var)
       IMPLICIT NONE
@@ -596,6 +696,5 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_varid
-      INTEGER(i4) :: il_rec
+      !INTEGER(i4) :: il_rec
       INTEGER(i4) :: il_ind
 
@@ -606,9 +705,8 @@
       !----------------------------------------------------------------
       ! check if file opened
-      !IF( TRIM(td_file%c_name) == "unknown" )THEN
       IF( TRIM(td_file%c_name) == '' )THEN
 
-         CALL logger_error( " ADD VAR: structure file unknown" )
-         CALL logger_debug( " ADD VAR: you should have used file_init before "//&
+         CALL logger_error( " FILE ADD VAR: structure file unknown" )
+         CALL logger_debug( " FILE ADD VAR: you should have used file_init before "//&
          & "running file_add_var" )
 
@@ -617,17 +715,17 @@
          IF( TRIM(td_var%c_name) == '' .AND. &
          &   TRIM(td_var%c_stdname) == '' )THEN
-            CALL logger_error(" ADD VAR: variable not define ")
+            CALL logger_error(" FILE ADD VAR: variable without name ")
          ELSE
             ! check if variable already in file structure
-            il_varid=0
+            il_ind=0
             IF( ASSOCIATED(td_file%t_var) )THEN
-               il_varid=var_get_id( td_file%t_var(:), td_var%c_name,   &
-               &                                      td_var%c_stdname )
+               il_ind=var_get_index( td_file%t_var(:), td_var%c_name,   &
+               &                                       td_var%c_stdname )
             ENDIF
 
-            IF( il_varid /= 0 )THEN
+            IF( il_ind /= 0 )THEN
 
                CALL logger_error( &
-               &  " ADD VAR: variable "//TRIM(td_var%c_name)//&
+               &  " FILE ADD VAR: variable "//TRIM(td_var%c_name)//&
                &  ", standard name "//TRIM(td_var%c_stdname)//&
                &  ", already in file "//TRIM(td_file%c_name) )
@@ -641,31 +739,37 @@
             ELSE
 
-               CALL logger_info( &
-               &  " ADD VAR: add variable "//TRIM(td_var%c_name)//&
+               CALL logger_trace( &
+               &  " FILE ADD VAR: add variable "//TRIM(td_var%c_name)//&
                &  ", standard name "//TRIM(td_var%c_stdname)//&
                &  ", in file "//TRIM(td_file%c_name) )
 
-               ! if none, force to use variable dimension
-               IF( ALL( .NOT. td_file%t_dim(:)%l_use) )THEN
-                  td_file%t_dim(:)=td_var%t_dim(:)
-               ENDIF
-
                ! check used dimension 
                IF( file_check_var_dim(td_file, td_var) )THEN
 
+                  ! update dimension if need be
+                  DO ji=1,ip_maxdim
+                     IF( td_var%t_dim(ji)%l_use .AND. &
+                     &   .NOT. td_file%t_dim(ji)%l_use )THEN
+                        CALL file_add_dim(td_file,td_var%t_dim(ji))
+                     ENDIF
+                  ENDDO
+
+                  ! get index of new variable
                   SELECT CASE(td_var%i_ndim)
                      CASE(0)
                         il_ind=td_file%i_n0d+1
-                        il_rec=0
+                        !il_rec=0
                      CASE(1)
                         il_ind=td_file%i_n0d+td_file%i_n1d+1
-                        il_rec=1
+                        !il_rec=1
                      CASE(2)
                         il_ind=td_file%i_n0d+td_file%i_n1d+td_file%i_n2d+1
-                        il_rec=1
+                        !il_rec=1
                      CASE(3,4)
                         il_ind=td_file%i_n0d+td_file%i_n1d+td_file%i_n2d+td_file%i_n3d+1
-                        il_rec=td_file%t_dim(3)%i_len
+                        !il_rec=td_file%t_dim(3)%i_len
                   END SELECT
+                  CALL logger_info( &
+                     &  " FILE ADD VAR: variable index "//TRIM(fct_str(il_ind)))
 
                   IF( td_file%i_nvar > 0 )THEN
@@ -675,5 +779,5 @@
 
                         CALL logger_error( &
-                        &  " ADD VAR: not enough space to put variables "//&
+                        &  " FILE ADD VAR: not enough space to put variables "//&
                         &  "from "//TRIM(td_file%c_name)//&
                         &  " in variable structure")
@@ -682,7 +786,8 @@
 
                         ! save temporary variable of file structure
-                        tl_var(:)=td_file%t_var(:)
-
-                        DEALLOCATE( td_file%t_var )
+                        tl_var(:)=var_copy(td_file%t_var(:))
+
+                        CALL var_clean( td_file%t_var(:) )
+                        DEALLOCATE(td_file%t_var)
                         ALLOCATE( td_file%t_var(td_file%i_nvar+1), &
                         &         stat=il_status)
@@ -690,5 +795,5 @@
 
                            CALL logger_error( &
-                           &  " ADD VAR: not enough space to put variable "//&
+                           &  " FILE ADD VAR: not enough space to put variable "//&
                            &  "in file structure "//TRIM(td_file%c_name) )
 
@@ -697,18 +802,16 @@
                         ! copy variable in file before
                         ! variable with less than or equal dimension that new variable
-                        td_file%t_var( 1:il_ind-1 ) = tl_var( 1:il_ind-1 )
-
-                        ! variable with greater dimension than new variable
-                        td_file%t_var( il_ind+1 : td_file%i_nvar+1 ) = &
-                        &                 tl_var( il_ind : td_file%i_nvar )
-
-                        ! update id
-                        td_file%t_var( il_ind+1 : td_file%i_nvar+1 )%i_id = &
-                        &           tl_var( il_ind : td_file%i_nvar )%i_id + 1
-
-                        ! update record index
-                        td_file%t_var( il_ind+1 : td_file%i_nvar+1 )%i_rec = &
-                        & tl_var( il_ind : td_file%i_nvar )%i_rec + il_rec
-
+                        IF( il_ind > 1 )THEN
+                           td_file%t_var( 1:il_ind-1 ) = var_copy(tl_var(1:il_ind-1))
+                        ENDIF
+
+                        IF( il_ind < td_file%i_nvar )THEN
+                           ! variable with more dimension than new variable
+                           td_file%t_var( il_ind+1 : td_file%i_nvar+1 ) = &
+                           &        var_copy( tl_var(il_ind : td_file%i_nvar) )
+                        ENDIF
+
+                        ! clean
+                        CALL var_clean(tl_var(:))
                         DEALLOCATE(tl_var)
                      ENDIF
@@ -717,4 +820,5 @@
                   ! no variable in file structure
                      IF( ASSOCIATED(td_file%t_var) )THEN
+                        CALL var_clean(td_file%t_var(:))
                         DEALLOCATE(td_file%t_var)
                      ENDIF
@@ -723,5 +827,5 @@
 
                         CALL logger_error( &
-                        &  " ADD VAR: not enough space to put variable "//&
+                        &  " FILE ADD VAR: not enough space to put variable "//&
                         &  "in file structure "//TRIM(td_file%c_name) )
 
@@ -730,13 +834,14 @@
                   ENDIF
 
+                  ! add new variable in array of variable
                   ALLOCATE( tl_var(1), stat=il_status )
                   IF(il_status /= 0 )THEN
 
                      CALL logger_error( &
-                     &  " ADD VAR: not enough space to put variables from "//&
+                     &  " FILE ADD VAR: not enough space to put variables from "//&
                      &  TRIM(td_var%c_name)//" in variable structure")
 
                   ELSE
-                     tl_var(1)=td_var
+                     tl_var(1)=var_copy(td_var)
 
                      ! update dimension name in new variable
@@ -744,5 +849,5 @@
                   
                      ! add new variable
-                     td_file%t_var(il_ind)=tl_var(1)
+                     td_file%t_var(il_ind)=var_copy(tl_var(1))
 
                      ! update number of variable
@@ -755,21 +860,10 @@
                         CASE(2)
                            td_file%i_n2d=td_file%i_n2d+1
-                        CASE(3)
+                        CASE(3,4)
                            td_file%i_n3d=td_file%i_n3d+1
                      END SELECT
 
                      ! update variable id
-                     td_file%t_var(il_ind)%i_id=il_ind
-
-                     ! update record header index
-                     td_file%i_rhd=td_file%i_rhd+il_rec
-
-                     ! update record index
-                     IF( il_ind > 1 )THEN
-                        td_file%t_var(il_ind)%i_rec = &
-                        &     td_file%t_var(il_ind-1)%i_rec+il_rec
-                     ELSE
-                        td_file%t_var(il_ind)%i_rec = il_rec
-                     ENDIF
+                     td_file%t_var(il_ind)%i_id=var_get_unit(td_file%t_var(:))
 
                      ! update dimension used
@@ -780,11 +874,12 @@
                         ENDIF
                      ENDDO
-                     CALL dim_reorder(td_file%t_dim(:))
+
                      ! update number of dimension
                      td_file%i_ndim=COUNT(td_file%t_dim(:)%l_use)
 
-                     DEALLOCATE( tl_var )
+                     ! clean
+                     CALL var_clean( tl_var(:) )
+                     DEALLOCATE(tl_var)
                   ENDIF
-
                ENDIF
             ENDIF
@@ -793,18 +888,14 @@
 
    END SUBROUTINE file_add_var
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine delete a variable structure 
-   !> in file structure.
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name : variable name or standard name
-   !-------------------------------------------------------------------
-   !> @code
+   !> in file structure, given variable name or standard name.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      variable name or standard name
+   !-------------------------------------------------------------------
    SUBROUTINE file__del_var_name(td_file, cd_name )
       IMPLICIT NONE
@@ -815,5 +906,5 @@
 
       ! local variable
-      INTEGER(i4)       :: il_varid
+      INTEGER(i4)       :: il_ind
       !----------------------------------------------------------------
 
@@ -821,6 +912,6 @@
       IF( TRIM(td_file%c_name) == '' )THEN
 
-         CALL logger_error( " DEL VAR NAME: file structure unknown ")
-         CALL logger_debug( " DEL VAR NAME: you should have used file_init before "//&
+         CALL logger_error( " FILE DEL VAR NAME: file structure unknown ")
+         CALL logger_debug( " FILE DEL VAR NAME: you should have used file_init before "//&
          & "running file_del_var" )
 
@@ -829,17 +920,18 @@
          IF( td_file%i_nvar /= 0 )THEN
 
-            ! get the variable id, in file variable structure
-            il_varid=0
+            ! get the variable index, in file variable structure
+            il_ind=0
             IF( ASSOCIATED(td_file%t_var) )THEN
-               il_varid=var_get_id(td_file%t_var(:), cd_name )
+               il_ind=var_get_index(td_file%t_var(:), cd_name )
             ENDIF
-            IF( il_varid /= 0 )THEN
+
+            IF( il_ind /= 0 )THEN
    
-               CALL file_del_var(td_file, td_file%t_var(il_varid))
+               CALL file_del_var(td_file, td_file%t_var(il_ind))
 
             ELSE
 
                CALL logger_warn( &
-               &  " DEL VAR NAME: there is no variable with name or "//&
+               &  " FILE DEL VAR NAME: there is no variable with name or "//&
                &  "standard name "//TRIM(cd_name)//" in file "//&
                &  TRIM(td_file%c_name))
@@ -848,6 +940,7 @@
 
          ELSE
-            CALL logger_debug( " DEL VAR NAME: no variable associated to file "//&
-            &               TRIM(td_file%c_name) )
+            CALL logger_debug( " FILE DEL VAR NAME: "//&
+            &        "no variable associated to file "//&
+            &        TRIM(td_file%c_name) )
          ENDIF
 
@@ -855,20 +948,14 @@
 
    END SUBROUTINE file__del_var_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine delete a variable structure 
    !> in file structure, given variable structure.
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] td_var : variable structure
-   !> @todo
-   !> - verifier pose pas de souci de ne pas modifier id
-   !-------------------------------------------------------------------
-   !> @code
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_file   file structure
+   !> @param[in] td_var       variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE file__del_var_str(td_file, td_var)
       IMPLICIT NONE
@@ -880,5 +967,5 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_varid
+      INTEGER(i4) :: il_ind
       INTEGER(i4) :: il_rec
       TYPE(TVAR), DIMENSION(:), ALLOCATABLE :: tl_var
@@ -889,25 +976,204 @@
 
       ! check if file opened
-      !IF( TRIM(td_file%c_name) == "unknown" )THEN
       IF( TRIM(td_file%c_name) == '' )THEN
 
-         CALL logger_error( " DEL VAR: file structure unknown ")
-         CALL logger_debug( " DEL VAR: you should have used file_init before "//&
-         & "running file_del_var" )      
+         CALL logger_error( " FILE DEL VAR: file structure unknown ")
+         CALL logger_debug( " FILE DEL VAR: you should have used "//&
+         &  "file_init before running file_del_var" )      
 
       ELSE
 
-         ! check if variable already in file structure
-         il_varid=var_get_id(td_file%t_var(:), td_var%c_name, td_var%c_stdname )
-         IF( il_varid == 0 )THEN
-
+         ! check if variable is member of a file
+         IF( td_var%l_file )THEN
+            CALL logger_warn( &
+            &  " FILE DEL VAR: variable "//TRIM(td_var%c_name)//&
+            &  ", belong to file "//TRIM(td_file%c_name)//&
+            &  " and can not be removed.")
+         ELSE
+            ! check if variable already in file structure
+            il_ind=0
+            IF( ASSOCIATED(td_file%t_var) )THEN
+               il_ind=var_get_index( td_file%t_var(:), td_var%c_name, &
+               &                                       td_var%c_stdname )
+            ENDIF
+
+            IF( il_ind == 0 )THEN
+
+               CALL logger_warn( "FILE DEL VAR: no variable "//&
+               &     TRIM(td_var%c_name)//", in file "//TRIM(td_file%c_name) )
+
+               DO ji=1,td_file%i_nvar
+                  CALL logger_debug( "FILE DEL VAR: in file "//&
+                  &  TRIM(td_file%t_var(ji)%c_name)//", standard name "//&
+                  &  TRIM(td_file%t_var(ji)%c_stdname) )
+               ENDDO
+
+            ELSE
+               
+               CALL logger_trace( "FILE DEL VAR: delete variable "//&
+               &  TRIM(td_var%c_name)//", from file "//TRIM(td_file%c_name) )
+
+               ALLOCATE( tl_var(td_file%i_nvar-1), stat=il_status )
+               IF(il_status /= 0 )THEN
+
+                  CALL logger_error( &
+                  &  " FILE DEL VAR: not enough space to put variables from "//&
+                  &  TRIM(td_file%c_name)//" in temporary variable structure")
+
+               ELSE
+
+                  ! save temporary variable's file structure
+                  IF( il_ind > 1 )THEN
+                     tl_var(1:il_ind-1)=var_copy(td_file%t_var(1:il_ind-1))
+                  ENDIF
+
+                  IF( il_ind < td_file%i_nvar )THEN
+                     tl_var(il_ind:)=var_copy(td_file%t_var(il_ind+1:))
+                  ENDIF
+
+                  ! new number of variable in file
+                  td_file%i_nvar=td_file%i_nvar-1
+
+                  SELECT CASE(td_var%i_ndim)
+                     CASE(0)
+                        td_file%i_n0d=td_file%i_n0d-1
+                        il_rec=0
+                     CASE(1)
+                        td_file%i_n1d=td_file%i_n1d-1
+                        il_rec=1
+                     CASE(2)
+                        td_file%i_n2d=td_file%i_n2d-1
+                        il_rec=1
+                     CASE(3,4)
+                        td_file%i_n3d=td_file%i_n3d-1
+                        il_rec=td_file%t_dim(3)%i_len
+                  END SELECT
+
+                  CALL var_clean( td_file%t_var(:) )
+                  DEALLOCATE(td_file%t_var)
+
+                  IF( td_file%i_nvar > 0 )THEN
+                     ALLOCATE( td_file%t_var(td_file%i_nvar), stat=il_status )
+                     IF(il_status /= 0 )THEN
+
+                        CALL logger_error( " FILE DEL VAR: not enough space"//&
+                        &  "to put variables in file structure "//&
+                        &  TRIM(td_file%c_name) )
+
+                     ENDIF
+
+                     ! copy attribute in file before
+                     td_file%t_var(:)=var_copy(tl_var(:))
+
+                     ! update dimension used
+                     td_file%t_dim(:)%l_use=.FALSE.
+                     DO ji=1,ip_maxdim
+                        IF( ANY(td_file%t_var(:)%t_dim(ji)%l_use) )THEN
+                           td_file%t_dim(ji)%l_use=.TRUE.
+                        ENDIF
+                     ENDDO
+
+                     ! update number of dimension
+                     td_file%i_ndim=COUNT(td_file%t_dim(:)%l_use)
+
+                  ENDIF
+
+                  ! clean
+                  CALL var_clean(tl_var(:))
+                  DEALLOCATE(tl_var)
+                  
+               ENDIF 
+            ENDIF
+         ENDIF
+      ENDIF
+
+   END SUBROUTINE file__del_var_str
+   !-------------------------------------------------------------------
+   !> @brief This subroutine overwrite variable structure 
+   !> in file structure.
+   !
+   !> @warning change variable id in file structure.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] td_var       variable structure
+   !-------------------------------------------------------------------
+   SUBROUTINE file_move_var(td_file, td_var)
+      IMPLICIT NONE
+
+      ! Argument      
+      TYPE(TFILE), INTENT(INOUT) :: td_file
+      TYPE(TVAR),  INTENT(IN)    :: td_var
+
+      ! local variable
+      TYPE(TVAR) :: tl_var
+      !----------------------------------------------------------------
+
+      ! copy variable
+      tl_var=var_copy(td_var)
+
+      ! remove variable with same name or standard name
+      CALL file_del_var(td_file, tl_var)
+
+      ! add new variable
+      CALL file_add_var(td_file, tl_var)
+
+      ! clean
+      CALL var_clean(tl_var)
+
+   END SUBROUTINE file_move_var
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a global attribute 
+   !> in a file structure.<br/>
+   !> Do not overwrite, if attribute already in file structure.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] td_att       attribute structure
+   !-------------------------------------------------------------------
+   SUBROUTINE file_add_att(td_file, td_att)
+      IMPLICIT NONE
+
+      ! Argument      
+      TYPE(TFILE), INTENT(INOUT) :: td_file
+      TYPE(TATT),  INTENT(IN)    :: td_att
+
+      ! local variable
+      INTEGER(i4) :: il_status
+      INTEGER(i4) :: il_ind
+      TYPE(TATT), DIMENSION(:), ALLOCATABLE :: tl_att
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      ! check if file opened
+      IF( TRIM(td_file%c_name) == '' )THEN
+
+         CALL logger_error( " FILE ADD ATT: file structure unknown ")
+         CALL logger_debug( " FILE ADD ATT: you should have used file_init before "//&
+         & "running file_add_att" )      
+
+      ELSE
+
+         ! check if attribute already in file structure
+         il_ind=0
+         IF( ASSOCIATED(td_file%t_att) )THEN
+            il_ind=att_get_index( td_file%t_att(:), td_att%c_name )
+         ENDIF
+
+         IF( il_ind /= 0 )THEN
+         
             CALL logger_error( &
-            &  " DEL VAR: no variable "//TRIM(td_var%c_name)//&
-            &  ", in file "//TRIM(td_file%c_name) )
-
-            DO ji=1,td_file%i_nvar
+            &  " FILE ADD ATT: attribute "//TRIM(td_att%c_name)//&
+            &  ", already in file "//TRIM(td_file%c_name) )
+
+            DO ji=1,td_file%i_natt
                CALL logger_debug( &
-               &  " DEL VAR: in file "//TRIM(td_file%t_var(ji)%c_name)//&
-               &  ", standard name "//TRIM(td_file%t_var(ji)%c_stdname) )
+               &  " FILE ADD ATT: in file "//TRIM(td_file%t_att(ji)%c_name) )
             ENDDO
 
